diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index b53887f60..f050ae9ef 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -17,6 +17,7 @@ import com.mojang.nbt.CompoundTag;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.client.util.debug.Debug;
 import net.minecraft.client.world.chunk.provider.ChunkProviderViewer;
 import net.minecraft.core.Global;
 import net.minecraft.core.HitResult;
@@ -74,7 +75,7 @@ public class World implements WorldSource {
     public static boolean AUTOSAVE = true;
 
     private final int heightBlocks = 256;
-    private int heightBits = -1;
+    private final int heightBits = -1;
     private final List<LightUpdate> lightingToUpdate = new LinkedList<>();
     public List<Entity> loadedEntityList = new ArrayList<>();
     private final List<Entity> unloadedEntityList = new ArrayList<>();
@@ -91,7 +92,7 @@ public class World implements WorldSource {
     private final Set<NextTickListEntry> immediatelyUpdatedPositions = new HashSet<>();
     
     public boolean scheduledUpdatesAreImmediate = false;
-    private int dimensionColor = 0xffffff;
+    private final int dimensionColor = 0xffffff;
     public int skyDarken = 0;
     protected int updateLCG = new Random().nextInt();
     public int lightningFlicker = 0;
@@ -1098,7 +1099,7 @@ public class World implements WorldSource {
 		int skyLight = getSavedLightValue(LightLayer.Sky, x, y, z);
 		int blockLight = Math.max(getSavedLightValue(LightLayer.Block, x, y, z), blockLightValue);
 		
-		if(getBlockLitInteriorSurface(x, y, z)) {
+		if(getBlockLitInteriorSurface(x, y, z) || !isBlockOpaqueCube(x, y, z)) {
 			skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x, y + 1, z));
 			skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x, y - 1, z));
 			skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x + 1, y, z));
@@ -1387,11 +1388,7 @@ public class World implements WorldSource {
     {
         int i = MathHelper.floor_double(entity.x / Chunk.CHUNK_SIZE_X);
         int j = MathHelper.floor_double(entity.z / Chunk.CHUNK_SIZE_Z);
-        boolean flag = false;
-        if(entity instanceof EntityPlayer)
-        {
-            flag = true;
-        }
+        boolean flag = entity instanceof EntityPlayer;
         if(flag || isChunkLoaded(i, j))
         {
             if(entity instanceof EntityPlayer)
@@ -1415,7 +1412,7 @@ public class World implements WorldSource {
     {
         for(int i = 0; i < listeners.size(); i++)
         {
-            ((LevelListener) listeners.get(i)).entityAdded(entity);
+            listeners.get(i).entityAdded(entity);
         }
 
     }
@@ -1424,7 +1421,7 @@ public class World implements WorldSource {
     {
         for(int i = 0; i < listeners.size(); i++)
         {
-            ((LevelListener) listeners.get(i)).entityRemoved(entity);
+            listeners.get(i).entityRemoved(entity);
         }
 
     }
@@ -1641,7 +1638,7 @@ public class World implements WorldSource {
             f12 *= 0.45F;
             r = r * (1.0F - f12) + 0.8F * f12;
             g = g * (1.0F - f12) + 0.8F * f12;
-            b = b * (1.0F - f12) + 1.0F * f12;
+            b = b * (1.0F - f12) + f12;
         }
         return Vec3d.createVector(r, g, b);
     }
@@ -1781,7 +1778,7 @@ public class World implements WorldSource {
     {
         for(int i = 0; i < weatherEffects.size(); i++)
         {
-            Entity entity = (Entity)weatherEffects.get(i);
+            Entity entity = weatherEffects.get(i);
             entity.tick();
             if(entity.removed)
             {
@@ -1792,7 +1789,7 @@ public class World implements WorldSource {
         loadedEntityList.removeAll(unloadedEntityList);
         for(int j = 0; j < unloadedEntityList.size(); j++)
         {
-            Entity entity1 = (Entity)unloadedEntityList.get(j);
+            Entity entity1 = unloadedEntityList.get(j);
             int i1 = entity1.chunkCoordX;
             int k1 = entity1.chunkCoordZ;
             if(entity1.addedToChunk && isChunkLoaded(i1, k1))
@@ -1803,13 +1800,13 @@ public class World implements WorldSource {
 
         for(int k = 0; k < unloadedEntityList.size(); k++)
         {
-            releaseEntitySkin((Entity)unloadedEntityList.get(k));
+            releaseEntitySkin(unloadedEntityList.get(k));
         }
 
         unloadedEntityList.clear();
         for(int l = 0; l < loadedEntityList.size(); l++)
         {
-            Entity entity2 = (Entity)loadedEntityList.get(l);
+            Entity entity2 = loadedEntityList.get(l);
             if(entity2.vehicle != null)
             {
                 if(!entity2.vehicle.isRemoved() && entity2.vehicle.getPassenger() == entity2)
@@ -2057,33 +2054,7 @@ public class World implements WorldSource {
 
     public boolean isBoundingBoxBurning(AABB axisalignedbb)
     {
-        int i = MathHelper.floor_double(axisalignedbb.minX);
-        int j = MathHelper.floor_double(axisalignedbb.maxX + 1.0D);
-        int k = MathHelper.floor_double(axisalignedbb.minY);
-        int l = MathHelper.floor_double(axisalignedbb.maxY + 1.0D);
-        int i1 = MathHelper.floor_double(axisalignedbb.minZ);
-        int j1 = MathHelper.floor_double(axisalignedbb.maxZ + 1.0D);
-        if(areBlocksLoaded(i, k, i1, j, l, j1))
-        {
-            for(int k1 = i; k1 < j; k1++)
-            {
-                for(int l1 = k; l1 < l; l1++)
-                {
-                    for(int i2 = i1; i2 < j1; i2++)
-                    {
-                        int j2 = getBlockId(k1, l1, i2);
-                        if(j2 == Block.fire.id || j2 == Block.fluidLavaFlowing.id || j2 == Block.fluidLavaStill.id || j2 == Block.netherrackIgneous.id)
-                        {
-                            return true;
-                        }
-                    }
-
-                }
-
-            }
-
-        }
-        return false;
+        return isMaterialInBB(axisalignedbb, Material.fire, Material.lava);
     }
 
     public boolean handleMaterialAcceleration(AABB axisalignedbb, Material material, Entity entity, boolean addVelocity)
@@ -2107,16 +2078,12 @@ public class World implements WorldSource {
                 for(int i2 = i1; i2 < j1; i2++)
                 {
                     Block block = Block.blocksList[getBlockId(k1, l1, i2)];
-                    if(block == null || block.blockMaterial != material)
+                    if(block == null || !isMaterialInBB(axisalignedbb, material))
                     {
                         continue;
                     }
-                    double d1 = (float)(l1 + 1) - BlockFluid.getWaterVolume(getBlockMetadata(k1, l1, i2));
-                    if((double)l >= d1)
-                    {
-                        flag = true;
-                        block.handleEntityInside(this, k1, l1, i2, entity, vec3d);
-                    }
+                    flag = true;
+                    block.handleEntityInside(this, k1, l1, i2, entity, vec3d);
                 }
 
             }
@@ -2134,29 +2101,41 @@ public class World implements WorldSource {
         return flag;
     }
 
-    public boolean isMaterialInBB(AABB axisalignedbb, Material material)
+    public boolean isMaterialInBB(AABB axisalignedbb, Material ... materials)
     {
-        int i = MathHelper.floor_double(axisalignedbb.minX);
-        int j = MathHelper.floor_double(axisalignedbb.maxX + 1.0D);
-        int k = MathHelper.floor_double(axisalignedbb.minY);
-        int l = MathHelper.floor_double(axisalignedbb.maxY + 1.0D);
-        int i1 = MathHelper.floor_double(axisalignedbb.minZ);
-        int j1 = MathHelper.floor_double(axisalignedbb.maxZ + 1.0D);
-        for(int k1 = i; k1 < j; k1++)
+        int minX_i = MathHelper.floor_double(axisalignedbb.minX);
+        int maxX_i = MathHelper.floor_double(axisalignedbb.maxX + 1.0D);
+        int minY_i = MathHelper.floor_double(axisalignedbb.minY);
+        int maxY_i = MathHelper.floor_double(axisalignedbb.maxY + 1.0D);
+        int minZ_i = MathHelper.floor_double(axisalignedbb.minZ);
+        int maxZ_i = MathHelper.floor_double(axisalignedbb.maxZ + 1.0D);
+        for(int _x = minX_i; _x < maxX_i; _x++)
         {
-            for(int l1 = k; l1 < l; l1++)
+            for(int _y = minY_i; _y < maxY_i; _y++)
             {
-                for(int i2 = i1; i2 < j1; i2++)
+                for(int _z = minZ_i; _z < maxZ_i; _z++)
                 {
-                    Block block = Block.blocksList[getBlockId(k1, l1, i2)];
-                    if(block != null && block.blockMaterial == material)
-                    {
-                        return true;
+                    Block block = Block.blocksList[getBlockId(_x, _y, _z)];
+                    if(block != null) {
+                        boolean isMaterial = false;
+                        for (Material m : materials){
+                            if (block.blockMaterial == m) {
+                                isMaterial = true;
+                                break;
+                            }
+                        }
+                        if (!isMaterial) continue;
+
+                        block.setBlockBoundsBasedOnState(this, _x, _y, _z);
+                        if (axisalignedbb.intersectsWith(
+                            AABB.getBoundingBoxFromPool(_x + block.minZ, _y + block.minY, _z + block.minZ,
+                                _x + block.maxZ, _y + block.maxY, _z + block.maxZ))){
+                            return true;
+                        }
+
                     }
                 }
-
             }
-
         }
 
         return false;
@@ -2200,20 +2179,20 @@ public class World implements WorldSource {
         return false;
     }
 
-    public Explosion createExplosion(Entity entity, double d, double d1, double d2, 
-            float f)
+    public Explosion createExplosion(Entity entity, double x, double y, double z,
+                                     float explosionSize)
     {
-        return newExplosion(entity, d, d1, d2, f, false, false);
+        return newExplosion(entity, x, y, z, explosionSize, false, false);
     }
 
-    public Explosion newExplosion(Entity entity, double d, double d1, double d2, float f, boolean flag, boolean isCannonBall)
+    public Explosion newExplosion(Entity entity, double x, double y, double z, float explosionSize, boolean flaming, boolean isCannonBall)
     {
         Explosion explosion;
         if(!isCannonBall)
-            explosion = new Explosion(this, entity, d, d1, d2, f);
+            explosion = new Explosion(this, entity, x, y, z, explosionSize);
         else
-            explosion = new ExplosionCannonball(this, entity, d, d1, d2, f);
-        explosion.isFlaming = flag;
+            explosion = new ExplosionCannonball(this, entity, x, y, z, explosionSize);
+        explosion.isFlaming = flaming;
         explosion.doExplosionA();
         explosion.doExplosionB(true);
         return explosion;
@@ -2510,12 +2489,19 @@ public class World implements WorldSource {
     }
 
 	public void tick() {
+        Debug.push("misc");
 		immediatelyUpdatedPositions.clear();
+        Debug.change("weather");
 		weatherManager.tick();
+        Debug.change("misc");
 		updateSleepingPlayers();
+        Debug.change("spawning");
+        // TODO mob spawning seems to be the cause of many lag spikes, specifically the checks for is a mob is allowed to spawn at a certain xyz position seem to be the worst offenders
 		SpawnerMobs.performSpawning(this, spawnHostileMobs, spawnPeacefulMobs);
+        Debug.change("chunk");
 		chunkProvider.tick();
 
+        Debug.change("autosave");
 		int autosaveTimeInSeconds = Global.accessor.getAutosaveTimer();
 		int autosaveTimeInTicks = (autosaveTimeInSeconds * 20);
 
@@ -2524,6 +2510,7 @@ public class World implements WorldSource {
 			saveWorld(false, null, true);
 		}
 
+        Debug.change("misc");
 		if(getGameRuleValue(GameRules.DO_DAY_CYCLE)) {
 			levelData.setWorldTime(levelData.getWorldTime() + 1L);
 		}
@@ -2531,8 +2518,11 @@ public class World implements WorldSource {
 		runtime++;
 
 		tickUpdates(false);
+        Debug.change("blocks&cavesSounds");
 		updateBlocksAndPlayCaveSounds();
+        Debug.change("season&light");
 		updateSeasonAndLight();
+        Debug.pop();
 	}
 	
 	public void updateSeasonAndLight() {
@@ -2641,7 +2631,7 @@ public class World implements WorldSource {
         }
         for(int j = 0; j < count; j++)
         {
-            NextTickListEntry entry = (NextTickListEntry)scheduledTickTreeSet.first();
+            NextTickListEntry entry = scheduledTickTreeSet.first();
             if(!all && entry.delay > runtime)
             {
                 break;
@@ -2741,14 +2731,11 @@ public class World implements WorldSource {
         }
     }
 
-    public int countEntities(Class class1)
+    public int countEntities(Class<?> clazz)
     {
         int i = 0;
-        for(int j = 0; j < loadedEntityList.size(); j++)
-        {
-            Entity entity = (Entity)loadedEntityList.get(j);
-            if(class1.isAssignableFrom(entity.getClass()))
-            {
+        for (Entity entity : loadedEntityList) {
+            if (clazz.isAssignableFrom(entity.getClass())) {
                 i++;
             }
         }
@@ -2756,17 +2743,17 @@ public class World implements WorldSource {
         return i;
     }
 
-    public void addLoadedEntities(List list)
+    public void addLoadedEntities(List<Entity> list)
     {
         loadedEntityList.addAll(list);
         for(int i = 0; i < list.size(); i++)
         {
-            obtainEntitySkin((Entity)list.get(i));
+            obtainEntitySkin(list.get(i));
         }
 
     }
 
-    public void unloadEntities(List list)
+    public void unloadEntities(List<Entity> list)
     {
         unloadedEntityList.addAll(list);
     }
@@ -2917,29 +2904,26 @@ public class World implements WorldSource {
 
     public EntityPlayer getClosestPlayer(double x, double y, double z, double radius)
     {
-        double closestDistance = -1D;
+        if (radius < 0) return null;
+
+        double closestDistance = Double.POSITIVE_INFINITY;
         EntityPlayer entityplayer = null;
-        for(int i = 0; i < players.size(); i++)
-        {
-            EntityPlayer entityPlayer1 = players.get(i);
+
+        for (EntityPlayer entityPlayer1 : players) {
             double currentDistance = entityPlayer1.distanceToSqr(x, y, z);
-            if((radius < 0.0D || currentDistance < radius * radius) && (closestDistance == -1D || currentDistance < closestDistance))
-            {
+            if (currentDistance < radius * radius && (currentDistance < closestDistance)) {
                 closestDistance = currentDistance;
                 entityplayer = entityPlayer1;
             }
         }
-
         return entityplayer;
     }
 
     public EntityPlayer getPlayerEntityByName(String s)
     {
-        for(int i = 0; i < players.size(); i++)
-        {
-            if(s.equals(((EntityPlayer)players.get(i)).username))
-            {
-                return (EntityPlayer)players.get(i);
+        for (EntityPlayer player : players) {
+            if (s.equals(player.username)) {
+                return player;
             }
         }
 
@@ -3133,7 +3117,7 @@ public class World implements WorldSource {
         loadedEntityList.removeAll(unloadedEntityList);
         for(int i = 0; i < unloadedEntityList.size(); i++)
         {
-            Entity entity = (Entity)unloadedEntityList.get(i);
+            Entity entity = unloadedEntityList.get(i);
             int l = entity.chunkCoordX;
             int j1 = entity.chunkCoordZ;
             if(entity.addedToChunk && isChunkLoaded(l, j1))
@@ -3144,13 +3128,13 @@ public class World implements WorldSource {
 
         for(int j = 0; j < unloadedEntityList.size(); j++)
         {
-            releaseEntitySkin((Entity)unloadedEntityList.get(j));
+            releaseEntitySkin(unloadedEntityList.get(j));
         }
 
         unloadedEntityList.clear();
         for(int k = 0; k < loadedEntityList.size(); k++)
         {
-            Entity entity1 = (Entity)loadedEntityList.get(k);
+            Entity entity1 = loadedEntityList.get(k);
             if(entity1.vehicle != null)
             {
                 if(!entity1.vehicle.isRemoved() && entity1.vehicle.getPassenger() == entity1)
@@ -3299,10 +3283,10 @@ public class World implements WorldSource {
         playSoundEffect(null, id, x, y, z, data);
     }
 
-    public void playSoundEffect(EntityPlayer entityplayer, int i, int j, int k, int l, int i1)
+    public void playSoundEffect(EntityPlayer entityplayer, int id, int x, int y, int z, int data)
     {
         for (LevelListener listener : listeners) {
-            listener.levelEvent(entityplayer, i, j, k, l, i1);
+            listener.levelEvent(entityplayer, id, x, y, z, data);
         }
 
     }
@@ -3322,4 +3306,9 @@ public class World implements WorldSource {
         entityJoinedWorld(entityitem);
         return entityitem;
     }
+    public void sendGlobalMessage(String message){
+        for (EntityPlayer player: players){
+            player.sendMessage(message);
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/world/biome/Biome.java b/src/main/java/net/minecraft/core/world/biome/Biome.java
index ec02aaa15..90e9358eb 100644
--- a/src/main/java/net/minecraft/core/world/biome/Biome.java
+++ b/src/main/java/net/minecraft/core/world/biome/Biome.java
@@ -84,25 +84,17 @@ public class Biome
 
     public List<SpawnListEntry> getSpawnableList(EnumCreatureType creatureType)
     {
-        if(creatureType == EnumCreatureType.monster)
-        {
-            return spawnableMonsterList;
-        }
-        if(creatureType == EnumCreatureType.creature)
-        {
-            return spawnableCreatureList;
-        }
-        if(creatureType == EnumCreatureType.waterCreature)
-        {
-            return spawnableWaterCreatureList;
-        }
-        if(creatureType == EnumCreatureType.ambientCreature)
-        {
-            return spawnableAmbientCreatureList;
-        }
-        else
-        {
-            return null;
+        switch (creatureType){
+            case monster:
+                return spawnableMonsterList;
+            case creature:
+                return spawnableCreatureList;
+            case waterCreature:
+                return spawnableWaterCreatureList;
+            case ambientCreature:
+                return spawnableAmbientCreatureList;
+            default:
+                return null;
         }
     }
     
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index bd0db92c0..581f643fc 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -115,7 +115,7 @@ public class ChunkCache
 		int skyLight = worldObj.getSavedLightValue(LightLayer.Sky, x, y, z);
 		int blockLight = Math.max(worldObj.getSavedLightValue(LightLayer.Block, x, y, z), blockLightValue);
 		
-		if(getBlockLitInteriorSurface(x, y, z)) {
+		if(getBlockLitInteriorSurface(x, y, z) || !isBlockOpaqueCube(x, y, z)) {
 			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x, y + 1, z));
 			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x, y - 1, z));
 			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x + 1, y, z));
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkPosition.java b/src/main/java/net/minecraft/core/world/chunk/ChunkPosition.java
index c0432a2ac..7a669f107 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkPosition.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkPosition.java
@@ -1,14 +1,16 @@
 package net.minecraft.core.world.chunk;
 
 
-public class ChunkPosition
-{
+public class ChunkPosition {
+    public final int x;
+    public final int y;
+    public final int z;
 
-    public ChunkPosition(int i, int j, int k)
+    public ChunkPosition(int x, int y, int z)
     {
-        x = i;
-        y = j;
-        z = k;
+        this.x = x;
+        this.y = y;
+        this.z = z;
     }
 
     @Override
@@ -29,8 +31,4 @@ public class ChunkPosition
     {
         return x * 0x88f9fa + y * 0xef88b + z;
     }
-
-    public final int x;
-    public final int y;
-    public final int z;
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
index ec9563044..61f5cfd7c 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
@@ -17,7 +17,7 @@ public class WorldFeatureTreeCherry extends WorldFeatureTree {
 	@Override
 	public void placeLeaves(World world, int x, int y, int z, Random rand) {
 		if(rand.nextInt(5) == 0) {
-			world.setBlockAndMetadataWithNotify(x, y, z, Block.leavesCherryFlowering.id, world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING ? 1 : 0);
+			world.setBlockAndMetadataWithNotify(x, y, z, Block.leavesCherryFlowering.id, 0);
 		}else {
 			world.setBlockWithNotify(x, y, z, Block.leavesCherry.id);
 		}
diff --git a/src/main/java/net/minecraft/core/world/noise/BaseImprovedNoise.java b/src/main/java/net/minecraft/core/world/noise/BaseImprovedNoise.java
index e31c59774..0301eeb7d 100644
--- a/src/main/java/net/minecraft/core/world/noise/BaseImprovedNoise.java
+++ b/src/main/java/net/minecraft/core/world/noise/BaseImprovedNoise.java
@@ -39,9 +39,9 @@ public abstract class BaseImprovedNoise
 
     public double getValue(double x, double y, double z)
     {
-        int X = (int)Math.floor(x) & 255,                  // FIND UNIT CUBE THAT
-            Y = (int)Math.floor(y) & 255,                  // CONTAINS POINT.
-            Z = (int)Math.floor(z) & 255;
+        int X = (int)((long)Math.floor(x) & 255),                  // FIND UNIT CUBE THAT
+            Y = (int)((long)Math.floor(y) & 255),                  // CONTAINS POINT.
+            Z = (int)((long)Math.floor(z) & 255);
         x -= Math.floor(x);                                // FIND RELATIVE X,Y,Z
         y -= Math.floor(y);                                // OF POINT IN CUBE.
         z -= Math.floor(z);
@@ -52,13 +52,13 @@ public abstract class BaseImprovedNoise
             B = p[X+1]+Y, BA = p[B]+Z, BB = p[B+1]+Z;      // THE 8 CUBE CORNERS,
 
         return lerp(w, lerp(v, lerp(u, grad(p[AA  ], x  , y  , z   ),  // AND ADD
-                                       grad(p[BA  ], x-1, y  , z   )), // BLENDED
-                               lerp(u, grad(p[AB  ], x  , y-1, z   ),  // RESULTS
-                                       grad(p[BB  ], x-1, y-1, z   ))),// FROM  8
-                       lerp(v, lerp(u, grad(p[AA+1], x  , y  , z-1 ),  // CORNERS
-                                       grad(p[BA+1], x-1, y  , z-1 )), // OF CUBE
-                               lerp(u, grad(p[AB+1], x  , y-1, z-1 ),
-                                       grad(p[BB+1], x-1, y-1, z-1 ))));
+                                                            grad(p[BA  ], x-1, y  , z   )), // BLENDED
+                                             lerp(u, grad(p[AB  ], x  , y-1, z   ),  // RESULTS
+                                                            grad(p[BB  ], x-1, y-1, z   ))),// FROM  8
+                              lerp(v, lerp(u, grad(p[AA+1], x  , y  , z-1 ),  // CORNERS
+                                                            grad(p[BA+1], x-1, y  , z-1 )), // OF CUBE
+                                             lerp(u, grad(p[AB+1], x  , y-1, z-1 ),
+                                                         grad(p[BB+1], x-1, y-1, z-1 ))));
     }
 
     protected double grad(int hash, double x, double y)
diff --git a/src/main/java/net/minecraft/core/world/pathfinder/IdHashMap.java b/src/main/java/net/minecraft/core/world/pathfinder/IdHashMap.java
index 56d75d775..32f718c54 100644
--- a/src/main/java/net/minecraft/core/world/pathfinder/IdHashMap.java
+++ b/src/main/java/net/minecraft/core/world/pathfinder/IdHashMap.java
@@ -1,8 +1,7 @@
 package net.minecraft.core.world.pathfinder;
 
-public class IdHashMap
-{
-    private transient Entry[] entries;
+public class IdHashMap<T> {
+    private transient Entry<T>[] entries;
     private transient int count;
     private int threshold;
     private final float growFactor = 0.75F;
@@ -25,10 +24,10 @@ public class IdHashMap
         return i & j - 1;
     }
 
-    public Object get(int id)
+    public T get(int id)
     {
         int j = getHash(id);
-        for(Entry mchashentry = entries[getEntryIndex(j, entries.length)]; mchashentry != null; mchashentry = mchashentry.next)
+        for(Entry<T> mchashentry = entries[getEntryIndex(j, entries.length)]; mchashentry != null; mchashentry = mchashentry.next)
         {
             if(mchashentry.hash == id)
             {
@@ -44,10 +43,10 @@ public class IdHashMap
         return lookupEntry(i) != null;
     }
 
-    final Entry lookupEntry(int i)
+    final Entry<T> lookupEntry(int i)
     {
         int j = getHash(i);
-        for(Entry mchashentry = entries[getEntryIndex(j, entries.length)]; mchashentry != null; mchashentry = mchashentry.next)
+        for(Entry<T> mchashentry = entries[getEntryIndex(j, entries.length)]; mchashentry != null; mchashentry = mchashentry.next)
         {
             if(mchashentry.hash == i)
             {
@@ -59,11 +58,11 @@ public class IdHashMap
     }
 
 
-    public void add(int key, Object item)
+    public void add(int key, T item)
     {
         int j = getHash(key);
         int k = getEntryIndex(j, entries.length);
-        for(Entry mchashentry = entries[k]; mchashentry != null; mchashentry = mchashentry.next)
+        for(Entry<T> mchashentry = entries[k]; mchashentry != null; mchashentry = mchashentry.next)
         {
             if(mchashentry.hash == key)
             {
@@ -77,7 +76,7 @@ public class IdHashMap
 
     private void grow(int i)
     {
-        Entry amchashentry[] = entries;
+        Entry<T>[] amchashentry = entries;
         int j = amchashentry.length;
         if(j == 0x40000000)
         {
@@ -85,7 +84,7 @@ public class IdHashMap
             return;
         } else
         {
-            Entry amchashentry1[] = new Entry[i];
+            Entry<T>[] amchashentry1 = new Entry[i];
             copy(amchashentry1);
             entries = amchashentry1;
             threshold = (int)((float)i * growFactor);
@@ -93,13 +92,13 @@ public class IdHashMap
         }
     }
 
-    private void copy(Entry[] amchashentry)
+    private void copy(Entry<T>[] amchashentry)
     {
-        Entry amchashentry1[] = entries;
+        Entry<T>[] amchashentry1 = entries;
         int i = amchashentry.length;
         for(int j = 0; j < amchashentry1.length; j++)
         {
-            Entry mchashentry = amchashentry1[j];
+            Entry<T> mchashentry = amchashentry1[j];
             if(mchashentry == null)
             {
                 continue;
@@ -107,7 +106,7 @@ public class IdHashMap
             amchashentry1[j] = null;
             do
             {
-                Entry mchashentry1 = mchashentry.next;
+                Entry<T> mchashentry1 = mchashentry.next;
                 int k = getEntryIndex(mchashentry.entryIndex, i);
                 mchashentry.next = amchashentry[k];
                 amchashentry[k] = mchashentry;
@@ -117,19 +116,19 @@ public class IdHashMap
 
     }
 
-    public Object remove(int id)
+    public T remove(int id)
     {
-        Entry mchashentry = removeEntry(id);
+        Entry<T> mchashentry = removeEntry(id);
         return mchashentry != null ? mchashentry.value : null;
     }
 
-    final Entry removeEntry(int id)
+    final Entry<T> removeEntry(int id)
     {
         int j = getHash(id);
         int k = getEntryIndex(j, entries.length);
-        Entry mchashentry = entries[k];
-        Entry mchashentry1;
-        Entry mchashentry2;
+        Entry<T> mchashentry = entries[k];
+        Entry<T> mchashentry1;
+        Entry<T> mchashentry2;
         for(mchashentry1 = mchashentry; mchashentry1 != null; mchashentry1 = mchashentry2)
         {
             mchashentry2 = mchashentry1.next;
@@ -155,7 +154,7 @@ public class IdHashMap
     public void clear()
     {
         versionStamp++;
-        Entry[] amchashentry = entries;
+        Entry<T>[] amchashentry = entries;
         for(int i = 0; i < amchashentry.length; i++)
         {
             amchashentry[i] = null;
@@ -164,24 +163,23 @@ public class IdHashMap
         count = 0;
     }
 
-    private void insert(int i, int j, Object obj, int k)
+    private void insert(int i, int j, T obj, int k)
     {
-        Entry mchashentry = entries[k];
-        entries[k] = new Entry(i, j, obj, mchashentry);
+        Entry<T> mchashentry = entries[k];
+        entries[k] = new Entry<>(i, j, obj, mchashentry);
         if(count++ >= threshold)
         {
             grow(2 * entries.length);
         }
     }
 
-    class Entry
-    {
+    static class Entry<T> {
         final int hash;
-        Object value;
-        Entry next;
+        T value;
+        Entry<T> next;
         final int entryIndex;
 
-        Entry(int entryIndex, int hash, Object value, Entry next)
+        Entry(int entryIndex, int hash, T value, Entry<T> next)
         {
             this.value = value;
             this.next = next;
diff --git a/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java b/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
index a22cda382..ecafc696f 100644
--- a/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
+++ b/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
@@ -11,13 +11,13 @@ public class PathFinder
 {
     private final WorldSource worldSource;
     private final BinaryHeap openSet;
-    private final IdHashMap closedSet;
+    private final IdHashMap<Node> closedSet;
     private final Node[] neighbors;
 
     public PathFinder(WorldSource worldSource)
     {
         openSet = new BinaryHeap();
-        closedSet = new IdHashMap();
+        closedSet = new IdHashMap<>();
         neighbors = new Node[32];
         this.worldSource = worldSource;
     }
@@ -165,10 +165,10 @@ public class PathFinder
         return pathpoint1;
     }
 
-    private final Node getNode(int x, int y, int z)
+    private Node getNode(int x, int y, int z)
     {
         int l = Node.createHash(x, y, z);
-        Node pathpoint = (Node) closedSet.get(l);
+        Node pathpoint = closedSet.get(l);
         if(pathpoint == null)
         {
             pathpoint = new Node(x, y, z);
